#include "chadic.h"

#define PATH_NUM            8192 /* 1000 */
#define INFO_MAX            129 /* ̣ʸȤƳǼ륹åȤΥ */
#define CHA_INPUT_SIZE      8192

/* for debug */
#if 0
#define debug_print(s) {printf("[%s:%d:%s]\n",__FILE__,__LINE__,s);fflush(stdout);}
#else
#define debug_print(s)
#endif


/*
 * structures
 */

typedef struct _mrph2_t {
    char	*midasi;
    char	*yomi;
    char        *info; /* ̣ʸȤƳǼ륹å */
    short	base_length;

#ifdef VGRAM
    unsigned short hinsi;
#else
    unsigned char hinsi;
    unsigned char bunrui;
#endif
    unsigned char ktype;
    unsigned char kform;
    char	is_undef;

    unsigned char weight;
    short	length;
    short	con_tbl;
} mrph2_t;

typedef struct _path_t {
    short mrph_p;
    short state;
    short start;
    short end;
    int   cost;
    short *path;     /* Υѥξ */
} path_t;

/*
 * global variables
 */

extern mrph2_t Mrph[];
extern path_t Path[];
extern int Path_num;
extern int Con_cost_weight, Mrph_cost_weight, Cost_width;
extern int Undef_cost, Undef_hinsi, Undef_con_tbl, Undef_con_cost;
#ifndef VGRAM
extern int Undef_bunrui;
#endif

/* init.c */
extern char *chasen_init();

/* print.c */
extern void print_mrph();
extern void print_best_path();
extern void print_all_mrph();
extern void print_all_path();

/* parse.c */
extern char *take_data();
extern int chasen_sent();

/* chacend.c */
void chasend_error(const char* fmt, ...);
void chasend_putc(int c);
void chasend_puts(const char* s);
void chasend_printf(const char* fmt, ...);
void chasen_terminate_line(void);
